<?php

/**
* Base command
*/
require_once('BaseValidatorCommand.class.php');

/**
* This command is a data access object (DAO) that approves
* a Fortune submission
*
* @author Tony Bibbs <tony AT geeklog DOT net>
*
*/
class deleteFortune extends BaseValidatorCommand {
    /**
    * Constructor
    *
    * @author Tony Bibbs <tony AT geeklog DOT net>
    *
    */
    function deleteFortune()
    {
        $this->doValidation();
    }

    /**
    * Deletes a Fortune submission 
    *
    * @author Tony Bibbs <tony AT geeklog DOT net>
    * @access public
    * @return string Any error messages
    *
    */
    function executeCommand()
    {
        global $_TABLES, $_USER;

        // Validate input
        if (!$this->_isValidInput()) {
            return $this->getErrorMsgs();
        }

        DB_query("DELETE FROM {$_TABLES['fortune']} WHERE fortune_id = {$_GET['id']} AND issubmission = 1");

    }

    /**
    * Validates the input was valid
    *
    * @author Tony Bibbs <tony AT geeklog DOT net>
    * @access private
    *
    */
    function doValidation() 
    {
        global $_LANG_FORTUNE, $_TABLES;

        if (empty($_GET['id'])) {
            $this->_errors[] = $_LANG_FORTUNE['noidprovidedmsg'];
        }

        if (DB_count($_TABLES['fortune'],Array('fortune_id','issubmission'), Array($_GET['id'],1)) == 0) {
            $this->_errors[] = $_LANG_FORTUNE['fortunenotfoundmsg'];
        }
    }
}

?>
