<?php

/**
* Base abstract class
*/
require_once($_CONF['path'] . 'plugins/fortune/commands/BaseCommand.class.php');

/**
* Shows the admin fortune editor
*
* @author Tony Bibbs <tony AT geeklog DOT net>
* 
*/
class getEditor extends BaseCommand {
    /**
    * Constructor
    *
    * Determines if we need to show the admin editor or
    * submission form
    *
    * @author Tony Bibbs <tony AT geeklog DOT net>
    * @access public
    *
    */
    function getEditor() 
    {
        if ($_GET['secure'] <> 1 AND !SEC_hasRights('fortune.edit')) {
            // Ensure user has access to the secure version of this 
            // command
            $this->_secureCommand = false;
        } else {
            parent::BaseCommand();
        }
    }

    /**
    * Shows either the admin editor or submissin editor depending on how
    * the command was accessed
    *
    8 @author Tony Bibbs <tony AT geeklog DOT net>
    * @access public
    *
    */
    function executeCommand()
    {
        global $_CONF, $_USER, $_TABLES, $LANG_ACCESS, $_GROUPS, $_LANG_FORTUNE, $PHP_SELF;

        $retval = COM_startBlock($_LANG_FORTUNE['fortuneeditor']);
        $fortune_templates = new Template($_CONF['path'] . 'plugins/fortune/templates');
        $fortune_templates->set_file(array('editor'=>'submission_form.thtml','security'=>'security_stuff.thtml'));
        $fortune_templates->set_var('site_url', $_CONF['site_url']);        
        $fortune_templates->set_var('action', $_CONF['site_url'] . '/fortune/');
        if (!empty($_GET['id'])) {
            $result = DB_query("SELECT * FROM {$_TABLES['fortune']} WHERE fortune_id = {$_GET['id']}");
            $A = DB_fetchArray($result);
            $access = SEC_hasAccess($A['owner_id'],$A['group_id'],$A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']);
            if ($access == 2 OR $access == 0) {
                $display .= COM_startBlock($_LANG_FORTUNE['accessdenied']);
                $display .= $_LANG_FORTUNE['adminaccesserrormsg'];
                $display .= COM_endBlock();
                return $display;
            }
            $A['username'] = DB_getItem($_TABLES['users'],'username',"uid={$A['fortune_uid']}");
            $fortune_templates->set_var('fortune_id', $_GET['id']);
        } else {
            $fortune_templates->set_var('fortune_id', '');
            $A['username'] = $_USER['username'];
            $A['fortune_uid'] = $_USER['uid'];
            $A['owner_id'] = $A['fortune_uid'];
            $A['group_id'] = DB_getItem($_TABLES['groups'], 'grp_id', "grp_name='Fortune Admin'");
            $A['perm_owner'] = 3;
            $A['perm_group'] = 2;
            $A['perm_members'] = 2;
            $A['perm_anon'] = 2;
            $access = 3;
        }
        $fortune_templates->set_var('lang_submittedby', $_LANG_FORTUNE['submittedby']);
        $fortune_templates->set_var('fortune_username', $A['username']);
        $fortune_templates->set_var('fortune_uid', $A['fortune_uid']);
        $fortune_templates->set_var('lang_author', $_LANG_FORTUNE['author']);
        $fortune_templates->set_var('fortune_author', $A['fortune_author']);
        $fortune_templates->set_var('lang_fortune', $_LANG_FORTUNE['fortune']);
        $fortune_templates->set_var('fortune_text', $A['fortune_text']);

        if ($this->_secureCommand) {
            $A['issubmission'] = 0;
            $fortune_templates->set_var('owner_username', DB_getItem($_TABLES['users'], 'username', "uid={$A['owner_id']}"));
            $fortune_templates->set_var('owner_id', $A['owner_id']);

            // user access info
            $fortune_templates->set_var('lang_accessrights',$LANG_ACCESS['accessrights']);
            $fortune_templates->set_var('lang_owner', $LANG_ACCESS['owner']);
            $fortune_templates->set_var('owner_username', DB_getItem($_TABLES['users'],'username',"uid = {$A['owner_id']}"));
            $fortune_templates->set_var('owner_id', $A['owner_id']);
            $fortune_templates->set_var('lang_group', $LANG_ACCESS['group']);

            $usergroups = SEC_getUserGroups();
            if ($access == 3) {
                $groupdd .= '<SELECT name="group_id">';
                for ($i = 0; $i < count($usergroups); $i++) {
                    $groupdd .= '<option value="' . $usergroups[key($usergroups)] . '"';
                    if ($A['group_id'] == $usergroups[key($usergroups)]) {
                        $groupdd .= ' SELECTED';
                    }
                    $groupdd .= '>' . key($usergroups) . '</option>';
                    next($usergroups);
                }
                $groupdd .= '</SELECT>';
            } else {
                // they can't set the group then
                $groupdd .= DB_getItem($_TABLES['groups'],'grp_name',"grp_id = {$A['group_id']}");
                $groupdd .= '<input type="hidden" name="group_id" value="' . $A['group_id'] . '">';
            }

            $fortune_templates->set_var('group_dropdown', $groupdd);
            $fortune_templates->set_var('lang_permissions', $LANG_ACCESS['permissions']);
            $fortune_templates->set_var('lang_perm_key', $LANG_ACCESS['permissionskey']);
            $fortune_templates->set_var('permissions_editor', SEC_getPermissionsHTML($A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']));
            $fortune_templates->set_var('permissions_msg', $LANG_ACCESS['permmsg']);
            $fortune_templates->parse('security_settings', 'security');
        } else {
            $A['issubmission'] = 1;
            $fortune_templates->set_var('fortune_username', 'Anonymous');
            $fortune_templates->set_var('fortune_uid', 1);
            $fortune_templates->set_var('security_settings', '');
        }
        $fortune_templates->set_var('issubmission', $A['issubmission']);

        $fortune_templates->set_var('lang_save', $_LANG_FORTUNE['save']);
        $fortune_templates->set_var('current_page', $_CONF['site_url'] . $PHP_SELF . '?cmd=showEditor');
        $fortune_templates->set_var('lang_cancel', $_LANG_FORTUNE['cancel']);
        $fortune_templates->set_var('lang_delete', $LANG24[11]);
        $fortune_templates->parse('output','editor');
        $retval .= $fortune_templates->finish($fortune_templates->get_var('output'));
        $retval .= COM_endBlock();

        return $retval;
    }
}

?>
