<?php

/**
* Parent command object
*/
require_once($_CONF['path'] . 'plugins/fortune/commands/BaseCommand.class.php');

/**
* Basic UI for users
* 
* This gets a set of random fortunes
*
* @author Tony Bibbs <tony AT geeklog DOT net>
*
*/
class getFortunes extends BaseCommand {
    /**
    * Constructor
    *
    * Sets this as a non-secure command
    *
    * @author Tony Bibbs <tony AT geeklog DOT net>
    * @access public
    *
    */
    function getFortunes()
    {
        $this->_secureCommand = false;
        parent::BaseCommand();
    }

    /**
    * Gets the set of random fortunes
    *
    * @author Tony Bibbs <tony AT geeklog DOT net>
    * @access public
    *
    */
    function executeCommand()
    {
        global $_TABLES, $PHP_SELF, $_LANG_FORTUNE, $_CONF, $_USER, $_GROUPS;

        $retval = COM_startBlock($_LANG_FORTUNE['fortunes']);
        $fortune_templates = new Template($_CONF['path'] . 'plugins/fortune/templates');
        $fortune_templates->set_file(array('fortunes'=>'random_fortunes.thtml','row'=>'single_fortune.thtml'));
        $fortune_templates->set_var('site_url', $_CONF['site_url']);
        $fortune_templates->set_var('lang_addfortune', $_LANG_FORTUNE['addfortune']);
        $fortune_templates->set_var('lang_morefortunes', $_LANG_FORTUNE['morefortunes']);

        $sql = "SELECT * FROM {$_TABLES['fortune']} WHERE issubmission = 0 ";
        $sqlOrderBy = "ORDER BY RAND(" . (double)microtime()*1000000 . ") ";
        $groupWhere .= 'AND (';
        if (!empty ($_USER['uid'])) {
            $groupList = '';
            foreach ($_GROUPS as $grp) {
                $groupList .= $grp . ',';
            }
            $groupList = substr ($groupList, 0, -1);
            $groupWhere.= "(owner_id = {$_USER['uid']} AND perm_owner >= 2) OR ";
            $groupWhere.= "(group_id IN ($groupList) AND perm_group >= 2) OR ";
            $groupWhere.= '(perm_members >= 2) OR ';
        }
        $groupWhere .= '(perm_anon >= 2)) ';
        if (empty($_GET['id'])) {
            $sql .= $groupWhere . $sqlOrderBy;
        } else {
            $sql .= "AND fortune_id = {$_GET['id']} " . $groupWhere;
        }
        $sql .= ' LIMIT 15';
        $result = DB_query($sql);
        $nRows = DB_numRows($result);
        if ($nRows > 0) {
            for ($i = 1; $i <= $nRows; $i++) {
                $A = DB_fetchArray($result);
                $fortune_templates->set_var('fortune_text', stripslashes($A['fortune_text']));
                $fortune_templates->set_var('fortune_author', stripslashes($A['fortune_author']));
                $fortune_templates->parse('fortune_rows','row',true);
            }
            $fortune_templates->parse('output','fortunes');
            $retval .= $fortune_templates->finish($fortune_templates->get_var('output'));
        } else {
            $retval .= $_LANG_FORTUNE['nofortunes'];
        }
        

        $retval .= COM_endBlock();

        return $retval;
    }
}
