<?php

require_once($_CONF['path'] . 'plugins/fortune/commands/BaseCommand.class.php');

class listFortunes extends BaseCommand {
    function executeCommand()
    {
        global $_TABLES, $PHP_SELF, $_LANG_FORTUNE, $_CONF;

        if (empty($_GET['page'])) {
            $page = 1;
        } else {
            $page = &$_GET['page'];
        }
        
        $retval = COM_startBlock($_LANG_FORTUNE['fortunelisting']);
        $fortune_templates = new Template($_CONF['path'] . 'plugins/fortune/templates');
        $fortune_templates->set_file(array('list'=>'list_fortunes.thtml','row'=>'listitem.thtml','subs'=>'moderation.thtml','sub_row'=>'submissionitem.thtml'));
        $fortune_templates->set_var('site_url', $_CONF['site_url']);
        $fortune_templates->set_var('site_admin_url', $_CONF['site_admin_url']);
        if (SEC_inGroup('Root')) {
            if (DB_count($_TABLES['plugins'],'pi_name','fortune') > 0) {
                $fortune_templates->set_var('install_option', '');
                $fortune_templates->set_var('uninstall_option', '<a href="' . $PHP_SELF . '?cmd=uninstall">' . $_LANG_FORTUNE['uninstall'] . '</a>');
            } else {
                $fortune_templates->set_var('install_option', '<a href="' . $PHP_SELF . '?cmd=install">' . $_LANG_FORTUNE['install'] . '</a>');
                $fortune_templates->set_var('uninstall_option', '');
            }
        } 
        $fortune_templates->set_var('form_action', $_CONF['site_url'] . $PHP_SELF);
        $fortune_templates->set_var('sort_order', $_POST['sort']);
        $fortune_templates->set_var('lang_instructions', $_LANG_FORTUNE['listinstructions']);
        $fortune_templates->set_var('lang_newfortune', $_LANG_FORTUNE['newfortune']);
        $fortune_templates->set_var('lang_search', $_LANG_FORTUNE['search']);

        $resultSubs = DB_query("SELECT * FROM {$_TABLES['fortune']} WHERE issubmission = 1 ORDER BY fortune_date DESC");
     
        $numSubs = DB_numRows($resultSubs); 
        if ($numSubs > 0 AND $page == 1) {
            // We have some submssions to show
            $fortune_templates->set_var('lang_youhavesubmissions', $_LANG_FORTUNE['youhavesubmissions']);
            $fortune_templates->set_var('lang_approve', $_LANG_FORTUNE['approve']);
            $fortune_templates->set_var('lang_delete', $_LANG_FORTUNE['delete']);
            for ($i = 1; $i <= $numSubs; $i++) {
                $A = DB_fetchArray($resultSubs);
                $fortune_templates->set_var('fortune_id',$A['fortune_id']);
                $fortune_templates->set_var('row_num',$i);
                $fortune_templates->set_var('fortune_author', $A['fortune_author']);
                $fortune_templates->set_var('fortune_text', substr($A['fortune_text'],0,40) . '...');
                $fortune_templates->parse('submission_rows','sub_row',true);
            }
            $fortune_templates->parse('fortune_submissions','subs');
        } else {
            $fortune_templates->set_var('fortune_submissions', '');
        }
        $fortune_templates->set_var('lang_author', $_LANG_FORTUNE['author']);
        $fortune_templates->set_var('lang_fortune', $_LANG_FORTUNE['fortune']);
        $limit = (50 * $page) - 50;
        $result = DB_query("SELECT * FROM {$_TABLES['fortune']} WHERE issubmission = 0 ORDER BY fortune_date DESC LIMIT $limit,50");
        $nRows = DB_numRows($result);
        if ($nRows > 0) {
            for ($i = 1; $i <= $nRows; $i++) {
                $A = DB_fetchArray($result);
                $fortune_templates->set_var('fortune_id',$A['fortune_id']);
                $fortune_templates->set_var('row_num',$i);
                $fortune_templates->set_var('fortune_author', $A['fortune_author']);
                $fortune_templates->set_var('fortune_text', substr($A['fortune_text'],0,60) . '...');
                $fortune_templates->parse('fortune_rows','row',true);
            }
        } else {
            $fortune_templates->set_var('fortune_rows','<tr><td colspan="3">' . $_LANG_FORTUNE['nofortunes'] . '</td></tr>');
        }
        
        // Print prev/next page links if needed
        if (DB_count($_TABLES['fortune']) > 50) {
            $prevpage = $page - 1;
            $nextpage = $page + 1;
            if ($pagestart >= 50) {
                $fortune_templates->set_var('previouspage_link', '<a href="' . $_CONF['site_admin_url'] . '/plugins/fortune/?cmd=listFortunes&amp;page=' . $prevpage . '">' . $_LANG_FORTUNE['previous'] . '</a> ');
            } else {
            $fortune_templates->set_var('previouspage_link','');
            }
            if ($pagestart <= (DB_count($_TABLES['fortune']) - 1)) {
                $fortune_templates->set_var('nextpage_link', '<a href="' . $_CONF['site_admin_url'] . '/plugins/fortune/?cmd=listFortunes&amp;page=' . $nextpage . '">' . $_LANG_FORTUNE['next'] . '</a> ');
            } else {
            $fortune_templates->set_var('nextpage_link','');
            }
        } else {
            $fortune_templates->set_var('previouspage_link','');
            $fortune_templates->set_var('nextpage_link','');
        }

        $fortune_templates->parse('output','list');
        $retval .= $fortune_templates->finish($fortune_templates->get_var('output'));

        $retval .= COM_endBlock();

        return $retval;
    }
}
