<?php

/**
* Base command
*/
require_once('BaseValidatorCommand.class.php');

/**
* This command is a data access object (DAO) that saves a
* fortune to the database
*
* @author Tony Bibbs <tony AT geeklog DOT net>
*
*/
class saveFortune extends BaseValidatorCommand {
    /**
    * Constructor
    *
    * @author Tony Bibbs <tony AT geeklog DOT net>
    *
    */
    function saveFortune()
    {
        $this->doValidation();
    }

    /**
    * Saves a fortune to the database
    *
    * @author Tony Bibbs <tony AT geeklog DOT net>
    * @access public
    * @return string Any error messages
    *
    */
    function executeCommand()
    {
        global $_TABLES, $_USER;

        if ($_POST['issubmission'] == 1) {
            $_POST['owner_id'] = 1;
            $_POST['group_id'] = DB_getItem($_TABLES['groups'], 'grp_id', "grp_name='Fortune Admin'");
            $perm_owner = 3;
            $perm_group = 2;
            $perm_members = 2;
            $perm_anon = 2;
        } else {
            list($perm_owner,$perm_group,$perm_members,$perm_anon) = SEC_getPermissionValues($_POST['perm_owner'],$_POST['perm_group'],$_POST['perm_members'],$_POST['perm_anon']);
        }
         

        // Validate input
        if (!$this->_isValidInput()) {
            return $this->getErrorMsgs();
        }

        if (!empty($_POST['fortune_id'])) {
            DB_query("DELETE FROM {$_TABLES['fortune']} WHERE fortune_id = {$_POST['fortune_id']}");
        }
        $date = date("Y-m-d H:i:s", time());

        // Convert array values to numeric permission values

        DB_query("INSERT INTO {$_TABLES['fortune']} (fortune_uid, fortune_date, fortune_author, fortune_text, owner_id, group_id, perm_owner, perm_group, perm_members, perm_anon, issubmission) VALUES ({$_POST['fortune_uid']}, '$date', '{$_POST['fortune_author']}', '{$_POST['fortune_text']}', {$_POST['owner_id']}, {$_POST['group_id']}, $perm_owner, $perm_group, $perm_members, $perm_anon, {$_POST['issubmission']})");

    }

    /**
    * Validates the input was valid
    *
    * @author Tony Bibbs <tony AT geeklog DOT net>
    * @access private
    *
    */
    function doValidation() 
    {
        global $_LANG_FORTUNE;

        if (empty($_POST['fortune_author'])) {
            $this->_errors[] = $_LANG_FORTUNE['noauthormsg'];
        }

        if (empty($_POST['fortune_text'])) {
            $this->_errors[] = $_LANG_FORTUNE['nofortunemsg'];
        }
    }
}

?>
