<?php

/**
* The fortune configuration file
*/
require_once($_CONF['path'] . 'plugins/fortune/config.php');

/**
* Base command that all other commands inherit from
*/
require_once($_CONF['path'] . 'plugins/fortune/commands/BaseCommand.class.php');


/**
* Fortune command factory
*
* This class will generate arbitrary commands and return them for execution
*
* @author Tony Bibbs <tony AT geeklog DOT com>
*
*/
class fCommandFactory {
 
    /**
    * This actually constructs a command and returns it
    *
    * @author Tony Bibbs <tony AT geeklog DOT com>
    * @access public
    * @param string $commandName Name of the command to create
    * @return object A descendant of BaseCommand
    *
    */
    function &getCommand($commandName)
    {
        global $_CONF;

        $classFile = $_CONF['path'] . 'plugins/fortune/commands/' . $commandName . '.class.php';
        if (file_exists($classFile)) {
            require_once($classFile);
        } else {
            print 'Cannot find class, ' . $classFile;
            exit;
        }

        $cmd = new $commandName;

        return $cmd;
    }
}
