<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Fortune Plugin 0.1 for Geeklog - The Ultimate Weblog                      |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// | This file does two things: 1) it implements the necessary Geeklog Plugin  |
// | API method and 2) implements all the common code needed by the Fortune    |
// | Pages' PHP files.                                                         |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002                                                        |
// |                                                                           |
// | Authors: Tony Bibbs - tony AT tonybibbs DOT com                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// $Id: functions.inc,v 1.1.1.1 2003/02/20 19:48:41 tony Exp $

$langfile = $_CONF['path'] . 'plugins/fortune/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile)) {
    require_once($langfile);
} else {
    require_once($_CONF['path'] . 'plugins/fortune/language/english.php');
}

include($_CONF['path'] . 'plugins/fortune/config.php');

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

function plugin_submit_fortune() 
{
    
}

/**
* Geeklog is checking to see if this plugin supports comments, tell it no!
* NOTE: to support comments you must use the same date/time based ID for your
* widget.  In other words, to make primary keys for your plugin you should call
* makesid().  Comments are keyed off of that...it is a limitation on how geeklog
* does comments.
*
*/
function plugin_commentsupport_fortune() 
{
    // Forutne will not use comments
    return false;
}

/**
* Geeklog is asking us to provide any new items that show up in the type
* drop-down on search.php.  Let's let users search fortunes!
*
*/
function plugin_searchtypes_fortune() 
{
    global $_LANG_FORTUNE;

    return $_LANG_FORTUNE['fortune'];
}

/**
* this searches for fortunes matching the user query and returns an array of
* for the header and table rows back to search.php where it will be formated and
* printed 
*
* @query            string          Keywords user is looking for
* @datestart        date/time       Start date to get results for
* @dateend          date/time       End date to get results for
* @topic            string          The topic they were searching in
* @type             string          Type of items they are searching
* @author           string          Get all results by this author
*
*/
function plugin_dopluginsearch_fortune($query, $datestart, $dateend, $topic, $type, $author) 
{
    global $_TABLES, $_CONF, $_LANG_FORTUNE;

    $sql = "SELECT fortune_id, fortune_uid, fortune_author, fortune_text, UNIX_TIMESTAMP(fortune_date) as day FROM {$_TABLES['fortune']} WHERE ";
    $sql .= "((fortune_author like '%$query%' OR fortune_author like '$query%' OR fortune_author like '%$query') ";
    $sql .= "OR (fortune_text like '%$query%' OR fortune_text like '$query%' OR fortune_text like '%$query')) ";

    if (!empty($datestart) AND !empty($dateend)) {
        $delim = substr($datestart, 4, 1);
        $DS = explode($delim,$datestart);
        $DE = explode($delim,$dateend);
        $startdate = mktime(0,0,0,$DS[1],$DS[2],$DS[0]);
        $enddate = mktime(0,0,0,$DE[1],$DE[2],$DE[0]) + 3600;
        $sql .= "AND (UNIX_TIMESTAMP(fortune_date) BETWEEN '$startdate' AND '$enddate') ";
    }

    if (!empty($author)) {
        $sql .= "AND (fortune_uid = '$author') ";
    }
    $sql    .= "ORDER BY fortune_date desc";

    // Perform search
    $result = DB_query($sql);
    
    // OK, now return coma delimited string of table header labels
    require_once($_CONF['path_system'] . 'classes/plugin.class.php');
    $plugin_results = new Plugin();
    $plugin_results->plugin_name = 'fortune';
    $plugin_results->searchlabel = $_LANG_FORTUNE['fortuneresults'];
    $plugin_results->addSearchHeading($_LANG_FORTUNE['id']);
    $plugin_results->addSearchHeading($_LANG_FORTUNE['author']);
    $plugin_results->addSearchHeading($_LANG_FORTUNE['fortune']);
    $plugin_results->num_searchresults = DB_numRows($result);

    // NOTE if any of your data items need to be links then add them here! 
    // make sure data elements are in an array and in the same order as your
    // headings above!
    for ($i = 1; $i <= $plugin_results->num_searchresults; $i++) {
        $A = DB_fetchArray($result);
        $A['fortune_author'] = stripslashes($A['fortune_author']);
        $A['fortune_text'] = substr(stripslashes($A['fortune_text']),0,30) . '...';
        $row = array('<a href="' . COM_buildURL ($_CONF['site_url'] . '/fortune/index.php?id=' . $A['fortune_id']) . '">' . $A['fortune_id'] . '</a>',$A['fortune_author'], $A['fortune_text']);
        $plugin_results->addSearchResult($row);
    }
    $plugin_results->num_itemssearched = DB_count($_TABLES['fortune']);

    return $plugin_results;
}
function plugin_submissioncount_fortune()
{
    global $_TABLES;

    return DB_count($_TABLES['fortune'],'issubmission','1');
}
/**
* This will put an option for fortunes in the command and control block on
* moderation.php
*
*/
function plugin_cclabel_fortune() 
{
    global $LANG_FORTUNE, $_CONF;

    if (SEC_hasRights('fortune.edit,fortune.delete','OR')) {
        return array($LANG_FORTUNE['fortune'],$_CONF['site_admin_url'] . '/plugins/fortune/index.php',$_CONF['site_url'] . '/fortune/images/fortune.gif');
    }

    return (false);
}

/**
* returns the administrative option for this plugin
*
*/
function plugin_getadminoption_fortune() 
{
    global $_CONF, $_LANG_FORTUNE, $_TABLES;

    if (SEC_hasRights('fortune.edit,fortune.delete','OR')) {
        return array($_LANG_FORTUNE['fortune'], $_CONF['site_url'] . '/fortune/?cmd=listFortunes', DB_count($_TABLES['fortune']));
    }	
}

/**
* Removes the datastructures for this plugin from the Geeklog database
*
* This may get called by the install routine to undo anything done to this
* point.  To do that, $steps will have a list of steps to undo
*
* @steps   Array    Holds all the steps that have been completed by the install
*
*/  
function plugin_uninstall_fortune($steps = '')
{
    global $_TABLES;

    // Uninstalls the fortunes plugin

    if (empty($steps) OR $steps['createtable'] == 1) {
        // Remove the fortune table 
        COM_errorLog('Dropping fortune table',1);
        DB_query("DROP TABLE {$_TABLES['fortune']}");
        COM_errorLog('...success',1);
    }

    // Remove security for this plugin

    // Remove the fortune admin group
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = 'sp_group_id'");

    if (empty($steps) OR $steps['insertgroup'] == 1) {
        COM_errorLog('Attempting to remove the Static Page Admin Group', 1);
        DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id");
        COM_errorLog('...success',1);
    }

    // Remove related features
    $edit_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'fortune.edit'");
    $delete_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'fortune.delete'");

    if (empty($steps) OR $steps['addededittogroup'] == 1) {
        // Remove access to those features 
        COM_errorLog('Attempting to remove rights to fortune.edit from all groups',1);
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $edit_id");
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['addeddeletetogroup'] == 1) {
        // Remove access to those features 
        COM_errorLog('Attempting to remove rights to fortune.delete from all groups',1);
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $delete_id");
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['addedrootuserstogroup'] == 1) {
        // Remove root users from the group
        COM_errorLog('Attempting to remove root users from admin of fortunes');
        DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id");
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['insertedfeatureedit'] == 1) {
        COM_errorLog('Attempting to remove the fortune.edit feature',1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $edit_id");
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['insertedfeaturedelete'] == 1) {
        COM_errorLog('Attempting to remove the fortune.delete feature',1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $delete_id");
        COM_errorLog('...success',1);
    }

    if (empty($steps) OR $steps['savedgroupid']) {
        COM_errorLog('Attempting to remove the group id from the vars table',1);
        DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = 'sp_group_id'");
        COM_errorLog('success',1);
    }

    // Unregister the plugin with Geeklog
    // Always attempt to remove these entries or lib-common.php would still
    // try and read our functions.inc file ...
    COM_errorLog('Attempting to unregister the plugin from Geeklog',1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'fortune'");
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = 'fortune'");
    COM_errorLog('...success',1);

    COM_errorLog('leaving plugin_uninstall_fortune',1);

    return true;
}

?>
